﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace memoWI
{
    public partial class ImgForm : Form
    {
        Form1 mainForm;
        Background bg;

        Point clickPoint;
        int selectionStartIndex;
        bool clickFlag;

        


        public Form1 MainForm
        {
            get { return mainForm; }
        }

        public Background Bg
        {
            get { return bg; }
        }
        
        public PictureBox PictureBox1
        {
            get { return pictureBox1; }
            set { pictureBox1 = value; }
        }



        public ImgForm(Form1 f)
        {
            InitializeComponent();
            mainForm = f;
            this.Icon = Properties.Resources.memoWI;
        }
        
        //フォームをアクティブにしない処理
        protected override void WndProc(ref Message m)
        {
            if (m.Msg == 0x0021)
            {
                m.Result = (IntPtr)3;
                return;
            }
            base.WndProc(ref m);
        }

        //マウスのボタンがクリックされたときのイベントハンドラ
        private void pictureBox1_MouseDown(object sender, MouseEventArgs e)
        {
            mainForm.Focus();

            Point clientPoint = mainForm.TBox.PointToClient(Control.MousePosition);
            selectionStartIndex = mainForm.TBox.GetCharIndexFromPosition(clientPoint);
            mainForm.TBox.SelectionStart = selectionStartIndex;

            mainForm.TBox.SelectionLength = 0;
            clickPoint = Control.MousePosition;
            clickFlag = true;
        }

        //文字列を選択する処理
        public void SelectString()
        {
            if (clickPoint != Control.MousePosition)
            {
                Point clientPoint = mainForm.TBox.PointToClient(Control.MousePosition);
                int selectEndIndex = mainForm.TBox.GetCharIndexFromPosition(clientPoint);
                mainForm.TBox.Select(selectionStartIndex, (selectEndIndex - selectionStartIndex));
            }
        }

        //マウスが動いたときのイベントハンドラ
        private void pictureBox1_MouseMove(object sender, MouseEventArgs e)
        {
            if (clickFlag)
            {
                this.SelectString();
            }
        }

        //マウスボタンを押した後に"離れた"ときのイベントハンドラ
        private void pictureBox1_MouseUp(object sender, MouseEventArgs e)
        {
            this.SelectString();
            clickFlag = false;
        }

        //背景画像に透明度が設定されたときに、表示するフォームをセットする
        public void SetBackground()
        {
            bg = new Background();
            bg.AddOwnedForm(this);
            bg.Size = this.Size;
            bg.Show();
            bg.Location = this.Location;
            
        }

        //画像が設定されていた時、D&Dされたときのイベントハンドラ
        private void ImgForm_DragDrop(object sender, DragEventArgs e)
        {
            string[] DDfilePaths = (string[])e.Data.GetData(DataFormats.FileDrop, false);

            string DDfilePath = DDfilePaths[0];

            if (mainForm.CheckExtension(DDfilePath) && mainForm.DeleteTextAnnounce())
            {
                mainForm.FilePath = DDfilePath;
                mainForm.TBox.Text = File.ReadAllText(DDfilePath, Encoding.Default);

            }
        }

        //D&Dされたファイルがフォームに入ってきたときに呼ばれる
        private void ImgForm_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.FileDrop))
                e.Effect = DragDropEffects.All;
            else
                e.Effect = DragDropEffects.None;
        }
        
        //Alt+Tabでこのフォームが表示されないようにする
        protected override CreateParams CreateParams
        {
            get
            {
                CreateParams cp = base.CreateParams;
                cp.ExStyle = 0x80 | cp.ExStyle;                
                return cp;
            }
        }
        


        private void ImgForm_ResizeEnd(object sender, EventArgs e)
        {
            Invalidate();
            PerformLayout();
        }
        

    }
}
