﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace memoWI
{
    public partial class Option : Form
    {
        Form1 _mainForm;
        Color bgColor;


        public Form1 mainForm
        {
            get { return _mainForm; }
            set { _mainForm = value; }
        }

        public PictureBox ImgBox
        {
            get { return BgimgPictureBox; }
        }

        public CheckBox StretchCheck
        {
            get { return StretchimgCheckBox; }
        }
        

        public Option(Form1 form)
        {
            InitializeComponent();
            mainForm = form;
            OptionInitializeComponent();
        }

        //設定した項目をメインのフォームに反映させる
        public void SetOption()
        {
            SetBgColImg();

            if (OpacityNumericUpDown.Value != 0)
            {
                SetOpacity();
            }
            else
                mainForm.Opacity = 1;

            SetTopMost();
            mainForm.TBox.ForeColor = CharColPictureBox.BackColor;

            mainForm.Focus();
        }

        //メインフォームに背景色or背景画像を設定する
        private void SetBgColImg()
        {
            if (BgcolRadioButton.Checked)
            {
                mainForm.TBox.BackColor = bgColor;
                if (mainForm.imgForm != null)
                {
                    if (mainForm.imgForm.Bg != null)
                    {
                        mainForm.imgForm.Owner = null;
                        mainForm.imgForm.Bg.Close();
                    }

                    mainForm.Owner = null;
                    mainForm.imgForm.Close();                    
                    mainForm.imgForm = null;
                    

                    if (mainForm.XpFlag)
                    {
                        mainForm.Dmm.Close();
                        mainForm.Dmm = null;
                    }
                }
            }
            else
            {
                if ((mainForm.imgForm != null) && (mainForm.imgForm.Bg != null))
                {
                    mainForm.imgForm.Owner = null;
                    mainForm.imgForm.Bg.Close();
                }


                if (BgimgPictureBox.Image != null)
                {
                    SetImgForm();
                    if (OpacityimgNumericUpDown.Value != 0)
                    {
                        mainForm.imgForm.SetBackground();
                        mainForm.imgForm.Opacity = 1 - ((double)OpacityimgNumericUpDown.Value * 0.01);

                        if (mainForm.XpFlag)
                        {
                            mainForm.imgForm.Owner = null;
                            mainForm.imgForm.Bg.AddOwnedForm(mainForm.imgForm);
                            mainForm.Dmm.AddOwnedForm(mainForm.imgForm.Bg);
                        }
                    }
                }
            }
        }
        
        //オプションの各項目の初期化を行う
        private void OptionInitializeComponent()
        {            
            OpacityNumericUpDown.Value = 100 - ((decimal)mainForm.Opacity * 100);
            InitializeBgColImg();
            CharColPictureBox.BackColor = mainForm.TBox.ForeColor;
            CurColComboBox.Text = InitializeCurCol();
        }

        //オプションの背景色or背景画像項目の初期化をする
        private void InitializeBgColImg()
        {
            if (mainForm.imgForm == null)
            {
                BgcolRadioButton.Checked = true;
                bgColor = mainForm.TBox.BackColor;
                NowColPictureBox.BackColor = bgColor;
            }
            else
            {
                BgimgRadioButton.Checked = true;
                BgimgPictureBox.Image = mainForm.imgForm.PictureBox1.Image;
                if (mainForm.imgForm.PictureBox1.SizeMode == PictureBoxSizeMode.StretchImage)
                    StretchimgCheckBox.Checked = true;

                if (mainForm.imgForm.Bg != null)
                {
                    OpacityimgNumericUpDown.Value = 100 - ((decimal)mainForm.imgForm.Opacity * 100);
                }
            }

            CheckedChange();
        }

        //BgcolRadioButtonのチェック状態が変わったときに呼ばれるイベントハンドラ
        private void BgcolRadioButton_CheckedChange(object sender, EventArgs e)
        {
            CheckedChange();
        }

        //背景タブの各コントロールの有効/無効を切り替える
        private void CheckedChange()
        {
            if (BgcolRadioButton.Checked)
            {
                BgimgLabel.Enabled = false;
                BgimgPictureBox.Enabled = false;
                BgimgChangeButton.Enabled = false;
                OpacityimgLabel.Enabled = false;
                OpacityimgNumericUpDown.Enabled = false;
                StretchimgCheckBox.Enabled = false;
                NowColLabel.Enabled = true;
                NowColPictureBox.Enabled = true;
                ColChangeButton.Enabled = true;                
            }
            else
            {
                BgimgLabel.Enabled = true;
                BgimgPictureBox.Enabled = true;
                BgimgChangeButton.Enabled = true;
                OpacityimgLabel.Enabled = true;
                OpacityimgNumericUpDown.Enabled = true;
                StretchimgCheckBox.Enabled = true;
                NowColLabel.Enabled = false;
                NowColPictureBox.Enabled = false;
                ColChangeButton.Enabled = false;
            }
        }        

        //「背景色を変更」ボタンを押したときのイベントハンドラ
        private void ColChangeButton_Click(object sender, EventArgs e)
        {
            DialogResult dr = colorDialog1.ShowDialog();

            if (dr == DialogResult.OK)
            {
                bgColor = colorDialog1.Color;
                NowColPictureBox.BackColor = bgColor;
            }
                
        }

        //「背景画像を変更」ボタンが押されたときのイベントハンドラ
        private void BgimgChangeButton_Click(object sender, EventArgs e)
        {
            DialogResult dr = openFileDialog1.ShowDialog();

            if (dr == DialogResult.OK)
            {
                BgimgPictureBox.Image = new Bitmap(openFileDialog1.FileName);
                mainForm.ImgFilePath = openFileDialog1.FileName;
            }
            
        }

        //メインフォームのテキスト編集領域に背景画像を疑似的に設定
        public void SetImgForm()
        {
            Color col = ChangeCurCol();

            mainForm.TBox.BackColor = col;
            mainForm.TransparencyKey = col;

            ImgForm imgF = new ImgForm(mainForm);

            imgF.PictureBox1.Image = BgimgPictureBox.Image;
            imgF.AddOwnedForm(mainForm);
            imgF.Size = mainForm.Size - new Size(0,2);            

            if(mainForm.imgForm != null)
                mainForm.imgForm.Close();            

            if (StretchimgCheckBox.Checked)
                imgF.PictureBox1.SizeMode = PictureBoxSizeMode.StretchImage;
                        
            imgF.Show();                        
            imgF.Location = mainForm.Location + new Size(0, 2);
            mainForm.imgForm = imgF;


            if (mainForm.XpFlag)
            {
                if (mainForm.Dmm != null)
                    mainForm.Dmm.Close();

                mainForm.Dmm = new Dummy();
                mainForm.Dmm.AddOwnedForm(mainForm.imgForm);
                mainForm.Dmm.Show();
            }
                       
        }        

        //全体の透明度を設定する
        private void SetOpacity()
        {
            mainForm.Opacity = 1 - ((double)OpacityNumericUpDown.Value * 0.01);
            if (mainForm.imgForm != null)
            {
                mainForm.imgForm.Opacity = mainForm.Opacity;
                if (mainForm.imgForm.Bg != null)
                {
                    mainForm.imgForm.Owner = null;
                    mainForm.imgForm.Bg.Close();
                }
                    
            }
        }

        //画像フォームなどの「常に手前表示」の設定をメインフォームと同じにする
        public void SetTopMost()
        {
            if (mainForm.imgForm != null)
            {
                mainForm.imgForm.TopMost = mainForm.TopMost;
                if (mainForm.imgForm.Bg != null)
                    mainForm.imgForm.Bg.TopMost = mainForm.TopMost;
            }
        }

        //「文字色を変更」ボタンが押されたときのイベントハンドラ
        private void CharColChangeButton_Click(object sender, EventArgs e)
        {
            DialogResult dr = colorDialog1.ShowDialog();

            if (dr == DialogResult.OK)
            {
                CharColPictureBox.BackColor = colorDialog1.Color;
            }
        }

        //テキストボックスのカーソルの色を変更するために、対応する色を返す
        private Color ChangeCurCol()
        {
            if (CurColComboBox.Text == "青")
                return Color.Chartreuse;
            else if (CurColComboBox.Text == "赤")
                return Color.SpringGreen;
            else if (CurColComboBox.Text == "緑")
                return Color.Indigo;
            else
                return Color.PowderBlue;
            
        }

        //テキストボックスのカーソルの色を判断してコンボボックスのTextに使うための文字列を返す
        private string InitializeCurCol()
        {
            if (mainForm.TBox.BackColor == Color.Chartreuse)
                return "青";
            else if (mainForm.TBox.BackColor == Color.SpringGreen)
                return "赤";
            else if (mainForm.TBox.BackColor == Color.Indigo)
                return "緑";
            else
                return "黒";
        }

    }
}
