﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace memoWI
{
    public partial class SearchDialogBox : Form
    {
        TextBox _mainText;
        Form1.SearRepMode mode;
        int searchIndex;

        public TextBox mainText{
            get{ return _mainText;}
            set{ _mainText = value;}
        }
        

        public SearchDialogBox(Form1.SearRepMode srMode, TextBox text)
        {
            InitializeComponent();
            mainText = text;
            mode = srMode;
            searchIndex = mainText.SelectionStart;
            if (srMode == Form1.SearRepMode.Search)
            {
                panel1.Visible = false;
                this.Size = new Size(538, 154);
            }
            else
                ReplaceInitializeComponent();
        }

        //検索対象の文字列が入力されたときに、各ボタンを有効にする
        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            if (textBox1.Text != "")
            {
                button1.Enabled = true;
                button3.Enabled = true;
                button4.Enabled = true;
            }
            else
            {
                button1.Enabled = false;
                button3.Enabled = false;
                button4.Enabled = false;
            }
            
        }

        //ダイアログボックスを閉じる
        private void button2_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        //実際の検索処理
        private bool SearchText(string str)
        {
            int findTextIndex;
            
            if (searchIndex < 0)
            {                
                MessageBox.Show("指定した文字列が見つかりませんでした", "memoWI", MessageBoxButtons.OK, MessageBoxIcon.Information);
                return false;
            }
            

            if (checkBox1.Checked)
            {
                if (radioButton1.Checked)
                    findTextIndex = mainText.Text.LastIndexOf(str, searchIndex);
                else
                    findTextIndex = mainText.Text.IndexOf(str, searchIndex);
            }
            else
            {
                if (radioButton1.Checked)
                    findTextIndex = mainText.Text.LastIndexOf(str, searchIndex,StringComparison.CurrentCultureIgnoreCase);
                else
                    findTextIndex = mainText.Text.IndexOf(str, searchIndex,StringComparison.CurrentCultureIgnoreCase);
            }


                if (findTextIndex == -1)
                {
                    MessageBox.Show("指定した文字列が見つかりませんでした", "memoWI", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    return false;
                }
                
            mainText.Select(findTextIndex,str.Length);
            mainText.ScrollToCaret();

            if (radioButton1.Checked)
                searchIndex = findTextIndex - 1;                
            else
                searchIndex = findTextIndex + str.Length;


            return true;

        }

        //「次を検索」の押したときのイベントハンドラ
        private void button1_Click(object sender, EventArgs e)
        {
            SearchText(textBox1.Text);
        }

        //ダイアログボックスにフォーカスが移ったときのイベントハンドラ
        private void SearchDialogBox_Activated(object sender, EventArgs e)
        {
            searchIndex = mainText.SelectionStart;
        }        

        //置換用ダイアログボックスのための整形
        private void ReplaceInitializeComponent()
        {
            button2.Location = new Point(411, 95);
            groupBox1.Location = new Point(225, 95);
            checkBox1.Location = new Point(14, 90);
            label2.Location = new Point(14, 115);
            numericUpDown1.Location = new Point(66, 115);
            this.Text = "置換";            
        }

        //透明度を変更
        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {
            this.Opacity = 1 - ((double)numericUpDown1.Value * 0.01);
        }

        //置換して次へ
        private void button3_Click(object sender, EventArgs e)
        {
            if (mainText.SelectionLength > 0)
            {
                int startIndex = mainText.SelectionStart;
                mainText.Text = mainText.Text.Remove(startIndex, mainText.SelectionLength);
                mainText.Text = mainText.Text.Insert(startIndex, textBox2.Text);
                bool searchResult = SearchText(textBox1.Text);
                mainText.Modified = true;

                if (!searchResult)
                    mainText.Select(startIndex, textBox2.Text.Length);
            }
            else
                SearchText(textBox1.Text);
                        
        }

        //すべて置換
        private void button4_Click(object sender, EventArgs e)
        {
            string temp = mainText.Text;
            mainText.Text = mainText.Text.Replace(textBox1.Text, textBox2.Text);
            mainText.Modified = true;            
            mainText.SelectionStart = 0;
        }

        

        

        
    }
}
